/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.blackberry.ui.rim;

import net.rim.device.api.ui.Screen;
import net.rim.device.api.ui.TouchEvent;
import net.rim.device.api.ui.VirtualKeyboard;
import net.rim.device.api.ui.component.ListField;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.UiEngineInstance;
import net.rim.device.api.ui.Ui;
import net.rim.device.api.system.Display;

import com.funambol.util.Log;

public class RimHomeScreen extends RimBasicHomeScreen {

    public RimHomeScreen() {
        super();
        style = Field.FIELD_TOP;

        // Lock screen orientation to portrait (this is only possible with 4.7
        // APIs)
        UiEngineInstance uiEngine = Ui.getUiEngineInstance();
        uiEngine.setAcceptableDirections(Display.DIRECTION_PORTRAIT);
    }

    public void onDisplay() {
        hideKeyboard();
        super.onDisplay();
    }

    public void onExposed() {
        hideKeyboard();
        super.onExposed();
    }

    protected HomeScreenList createHomeScreenList() {
        return new TouchableHomeScreenList();
    }

    private void hideKeyboard() {

        VirtualKeyboard vkbd = this.getVirtualKeyboard();
        if (vkbd != null) {
            vkbd.setVisibility(net.rim.device.api.ui.VirtualKeyboard.HIDE);
        }
    }

    private class TouchableHomeScreenList extends HomeScreenList {
        public TouchableHomeScreenList() {
            super();
        }

        protected boolean touchEvent(TouchEvent message) {

            if (message.getEvent() == TouchEvent.CLICK) {
                if (aloneButton) {
                    // We may need to ignore this event
                    RimButtonSyncSource buttonSource = (RimButtonSyncSource)listField.get(listField, 0);
                    if (!buttonSource.isClickValid(message.getGlobalX(1), message.getGlobalY(1))) {
                        invalidateNavClick = true;
                    }
                }
            }

            return false;
        }
    }

}
